using System;
using System.Collections.Generic;
using System.Text;
using CommonClass;
using System.Reflection;
using System.IO;

namespace CapitalBudgetingProblem
{
    class InformationData
    {
        private static string SetInputParserName(string extension)
        {
            StringBuilder result = new StringBuilder();
            result.Append(extension.Remove(0, 1));
            result[0] = char.ToUpper(result[0]);

            return result.ToString();
        }

        public static IInputParser GetInputParser(string parserName, string inputText)
        {
            Assembly me = Assembly.GetExecutingAssembly();

            parserName = SetInputParserName(parserName);

            return (IInputParser)(Activator.CreateInstance(me.GetType(string.Format("{0}.{1}.{2}", me.GetName().Name, "InputFileParsers", parserName)), new string[] { inputText }));
        }

        public static IInputParser GetInputParser(string parserName, StreamReader inputStream)
        {
            return GetInputParser(parserName, inputStream.ReadToEnd());
        }
    }
}
