using System;
using System.Collections.Generic;
using System.Text;
using System.Windows.Forms;

namespace CommonClass
{
    public class DecimalTextBox : TextBox
    {

        bool tocka = false, minus = false;

        public DecimalTextBox() 
            :base() 
        {            
            this.KeyPress += new KeyPressEventHandler(DecimalTextBox_KeyPress);
            this.Leave += new EventHandler(DecimalTextBox_Leave);
            this.TextChanged += new EventHandler(DecimalTextBox_TextChanged);
        }

        void DecimalTextBox_TextChanged(object sender, EventArgs e)
        {
            if (!this.Text.Contains("."))
                tocka = false;
            if (!this.Text.Contains("-"))
                minus = false;

        }

        void DecimalTextBox_Leave(object sender, EventArgs e)
        {
            double res;
            if (string.IsNullOrEmpty(this.Text))
                return;

            if (!double.TryParse(this.Text, out res))
            {
                MessageBox.Show("Broj je krivo upisan!", "Greka", MessageBoxButtons.OK);
                this.Focus();
            }
            else
            {
                tocka = false;
                minus = false;
            }
        }
        
        void DecimalTextBox_KeyPress(object sender, KeyPressEventArgs e)
        {            
            if(e.KeyChar == '.' && !tocka)
                tocka = true;
            else if ((sender as TextBox).Text.Length == 0 && e.KeyChar == '-' && !minus)
                minus = true;
            else if (e.KeyChar == (char)Keys.Back)
            {
            }
            else if (!char.IsDigit(e.KeyChar) && e.KeyChar != (char)Keys.Back)
            {
                e.Handled = true;
            }
        }

        public double GetValue
        {
            get
            {
                double rez;
                double.TryParse(this.Text, out rez);
                return rez;
            }
        }
    }
}
