using System;
using System.Collections.Generic;
using System.Text;
using CommonClass;
using System.Reflection;
using System.IO;
using System.Windows.Forms;

namespace CommonClass
{
    public class DynamicalCall
    {
        private static string SetInputParserName(string extension)
        {
            StringBuilder result = new StringBuilder();
            result.Append(extension.Remove(0, 1));
            result[0] = char.ToUpper(result[0]);

            return result.ToString();
        }

        /// <summary>
        /// 
        /// </summary>
        /// <param name="parserName"></param>
        /// <param name="inputText"></param>
        /// <param name="assembly"></param>
        /// <returns></returns>
        public static IInputParser GetInputParser(string parserName, string inputText, Assembly assembly)
        {
            try
            {
                parserName = SetInputParserName(parserName);
                return (IInputParser)(Activator.CreateInstance(assembly.GetType(string.Format("{0}.{1}.{2}", assembly.GetName().Name, "InputFileParsers", parserName)), new string[] { inputText }));
            }
            catch (Exception err)
            {
                MessageBox.Show(string.Format("Greka prilikom daohvacanja parsera ulaznih datoteka!{0}Greka:{0}{1}{0}ErrorStack:{0}{2}", Environment.NewLine, err.Message, err.StackTrace));
            }

            return null;
        }

        /// <summary>
        /// 
        /// </summary>
        /// <param name="parserName"></param>
        /// <param name="assembly"></param>
        /// <returns></returns>
        public static IOutputParser GetOutputParser(string parserName, Assembly assembly)
        {
            try
            {
                return (IOutputParser)(Activator.CreateInstance(assembly.GetType(string.Format("{0}.{1}.{2}", assembly.GetName().Name, "OutputFileParsers", parserName))));
            }
            catch (Exception err)
            {
                MessageBox.Show(string.Format("Greka prilikom daohvacanja parsera izlaznih datoteka!{0}Greka:{0}{1}{0}ErrorStack:{0}{2}", Environment.NewLine, err.Message, err.StackTrace));
            }

            return null;
        }

        public static IInputParser GetInputParser(string parserName, StreamReader inputStream, Assembly assembly)
        {
            return GetInputParser(parserName, inputStream.ReadToEnd(), assembly);
        }
    }
}
