using System;
using System.Collections.Generic;
using System.Text;
using System.IO;
using System.Runtime.Serialization.Formatters.Binary;
using System.Runtime.Serialization;
using System.Windows.Forms;

namespace CommonClass
{
    public class ProjectSerializer
    {
        public static void SaveProject(string path, object project)
        {
            Stream stream = null;
            try
            {
                stream = File.Open(path, FileMode.OpenOrCreate, FileAccess.Write);
                BinaryFormatter bformatter = new BinaryFormatter();
                bformatter.Serialize(stream, project);
            }
            catch (Exception err)
            {
                MessageBox.Show(string.Format("Greka prilikom spremanja projekta!\n\tError-> {0}\n\tStack-> {1}", err.Message, err.StackTrace), "Greka", MessageBoxButtons.OK);
            }
            finally
            {
                if(stream != null)
                    stream.Close();
            }
        }

        public static WorkingSession LoadProject(string path)
        {
            Stream stream = null;
            //Ukoliko bude greska prilokom ucitavajna projekta metoda vraca WorkingSesion formu!
            WorkingSession ws = new WorkingSession();
            try
            {
                stream = File.Open(path, FileMode.Open, FileAccess.Read);
                BinaryFormatter bformatter = new BinaryFormatter();
                ws = bformatter.Deserialize(stream) as WorkingSession;
            }
            catch (Exception err)
            {
                MessageBox.Show(string.Format("Greka prilikom spremanja projekta!\n\tError-> {0}\n\tStack-> {1}", err.Message, err.StackTrace), "Greka", MessageBoxButtons.OK);
            }
            finally
            {
                if(stream != null)
                    stream.Close();
            }
            return ws;
        }
    }
}
