using System;
using System.Collections.Generic;
using System.Text;
using CommonClass;

namespace GeneticAlgorithm
{
    public class SimpleGeneticAlgorithmEngine<T> : IAlgorithm
        where T : IGeneticAlgorithm
    {
        private T _geneticAlgorithm;
        public T GeneticAlgorithm
        {
            get { return _geneticAlgorithm; }
            set { _geneticAlgorithm = value; }
        }

        public SimpleGeneticAlgorithmEngine(T geneticAlgorithm)
        {
            _geneticAlgorithm = geneticAlgorithm;            
        }

        #region IAlgorithm Members

        Dictionary<object, object> IAlgorithm.GetResults
        {
            get { return _geneticAlgorithm.GetResults; }
        }

        Dictionary<object, object> IAlgorithm.SetInputData
        {
            set { _geneticAlgorithm.SetInputData = value; }
        }

        void IAlgorithm.Start()
        {
            _geneticAlgorithm.InitialPopulation();
            while (_geneticAlgorithm.StopConstranit())
            {
                _geneticAlgorithm.Selection();
                _geneticAlgorithm.Crossover();
                _geneticAlgorithm.Mutation();
            }
        }
        #endregion
    }
}
