using System;
using System.Collections.Generic;
using System.Text;

namespace LinearProgramming_SIMPLEX.GeneticAlgorithmClass
{
    class Binarni
    {
        private bool[] binBroj;

        public Binarni(uint broj, uint velicina)
        {
            if (broj >= Math.Pow(2, velicina))
                throw new ApplicationException("Zadani broj je prevelik za odabranu velicinu");

            binBroj = new bool[velicina];
            PretvoriUBinarni(broj);
        }

        public uint Velicina
        {
            get
            {
                return (uint)binBroj.Length;
            }
        }

        public uint Broj
        {
            get
            {
                return PretvoriUBroj();
            }

            set
            {
                PretvoriUBinarni(value);
            }
        }

        public uint this[int index]
        {
            get
            {
                return Convert.ToUInt32(binBroj[index]);
            }
            set
            {
                binBroj[index] = Convert.ToBoolean(value);
            }
        }

        private void PretvoriUBinarni(uint broj)
        {
            uint temp = broj;
            for (int i = 0; i < this.Velicina; i++)
            {
                if (temp % 2 == 1)
                {
                    this[i] = 1;
                }
                else
                {
                    this[i] = 0;
                }
                temp /= 2;
            }
        }

        private uint PretvoriUBroj()
        {
            uint temp = 0;
            for (int i = 0; i < this.Velicina; i++)
            {
                if (this[i] == 1)
                {
                    temp |= (uint)1 << i;
                }
            }
            return temp;
        }
    }
}
