using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using CommonClass;

namespace LinearProgramming_SIMPLEX.GeneticAlgorithmClass
{
    public partial class SimplexGAManager : GeneticAlgorithm.GeneticAlgorithmManager
    {
        public SimplexGAManager()
        {
            InitializeComponent();            
        }

        public override void StartAlgorithm()
        {
            if (InputData.Count == 0)
                MessageBox.Show("Pokrenite parsiranje ulazne datoteke kako bi mogli pokrenuti algoritam!", "Upozorenje");
            else
            {
                Progress.Start(this.Location);
                SetData();
                Progress.End();
            }
        }

        private void SetData()
        {
             Problem problem = new Problem(
                (double[])_inputData[InputFileParsers.KeyWordsSimplex.matricaCilja],
                (double[,])_inputData[InputFileParsers.KeyWordsSimplex.matricaUvjeta],
                (string[])_inputData[InputFileParsers.KeyWordsSimplex.operatorOdnosa],
                (int)_inputData[InputFileParsers.KeyWordsSimplex.dimenzijaProblema],
                (int)_inputData[InputFileParsers.KeyWordsSimplex.brojUvjeta],
                (double)nudPrecision.Value
                );
             GraniceProblema graniceProblema = new GraniceProblema(problem, dtbBorderPrecision.GetValue);
             graniceProblema.IzracunajGranice();
             GenetskiAlgoritam.BrojDecMjesta = (int)nudPrecision.Value;
             GenetskiAlgoritam.BrojDimenzija = (int)_inputData[InputFileParsers.KeyWordsSimplex.dimenzijaProblema];
             GenetskiAlgoritam.DonjaGranicaDimenzije = graniceProblema.DonjaGranica;
             GenetskiAlgoritam.GornjaGranicaDimenzije = graniceProblema.GornjaGranica;
             GenetskiAlgoritam ga = new GenetskiAlgoritam(
                 (int)nudPopulationNumber.Value,
                 (double)dtbProbabilityMutation.GetValue,
                 (int)nudGenerationNumber.Value,
                 (bool)_inputData[InputFileParsers.KeyWordsSimplex.max]
                 );

             ga.PokreniGA(problem, new RichTextBox(), false);               
        }
    }
}

