using System;
using System.Collections.Generic;
using System.Text;
using System.Runtime.Serialization;

namespace LinearProgramming_SIMPLEX.GeneticAlgorithmClass
{
    [Serializable]
    class Vektor : ISerializable
    {
        private double[] elementi;

        public Vektor(Vektor v)
        {
            this.elementi = (double[])v.elementi.Clone();
        }

        public Vektor(int velicina)
        {
            elementi = new double[velicina];
        }                

        public int Velicina
        {
            get
            {
                return elementi.Length;
            }
        }

        public double this[int index]
        {
            get
            {
                return elementi[index];
            }
            set
            {
                elementi[index] = value;
            }
        }

        #region ISerializable Members

        public Vektor(SerializationInfo info, StreamingContext contex)
        {
            elementi = info.GetValue("Elementi", typeof(double[])) as double[];
        }

        public void GetObjectData(SerializationInfo info, StreamingContext context)
        {
            info.AddValue("Elementi", elementi);            
        }

        #endregion
    }
}
