using System;
using System.Collections.Generic;
using System.Text;
using CommonClass;
using System.IO;
using System.Data;

namespace LinearProgramming_SIMPLEX.OutputFileParsers
{
    [Serializable]
    class WriteResults : IOutputParser
    {
        #region IOutputParser Members

        private StringBuilder textToWrite = new StringBuilder();
        private Dictionary<object, object> results;               
        public Dictionary<object, object> SetResults
        {
            set { results = value; }
        }

        private void MakeTextFromResults()
        {
            textToWrite.Length = 0;
            //textToWrite.Append(string.Format("Dimenzija\t\t\tGranica dimenzija\t\t\tRezultat{0}", Environment.NewLine));

            foreach (DataRow row in (results["Result"] as DataTable).Rows)
            {
                textToWrite.Append(string.Format("{0}\t{1}\t{2}{3}", row["Dimenzija"].ToString()
                                                                       , row["Granica dimenzije"].ToString()
                                                                       , row["Rezultat"].ToString()
                                                                       , Environment.NewLine
                                                )
                                  );
                
            }
        }

        public void WriteToFile(string path)
        {
            MakeTextFromResults();

            using (StreamWriter writer = new StreamWriter(path,false))
            {
                writer.WriteLine(textToWrite.ToString());
            }

        }
        #endregion
    }
}
