using System;
using System.Collections.Generic;
using System.Text;
using CommonClass;
using System.IO;
using TravelingSalesmanProblem_TSP.GeneticAlgorithmClass;

namespace TravelingSalesmanProblem_TSP.OutputFileParsers
{
    [Serializable]
    class WriteResults : IOutputParser
    {
        #region IOutputParser Members
        private StringBuilder textToWrite = new StringBuilder();
        private Dictionary<object, object> results;       
        public Dictionary<object, object> SetResults
        {
            set { results = value; }
        }

        private void MakeTextFromResults()
        {
            textToWrite.Length = 0;

            Kromosom najbolji = results["Results"] as Kromosom;
            foreach (int k in najbolji.Chromosome)
            {
                textToWrite.Append(string.Format("{1}{0}", Environment.NewLine, k.ToString()));
            }

            textToWrite.Append(string.Format("Duljina puta : {0}", najbolji.DuljinaPuta.ToString()));


        }

        public void WriteToFile(string path)
        {
            MakeTextFromResults();

            using (StreamWriter writer = new StreamWriter(path))
            {
                writer.WriteLine(textToWrite.ToString());
            }
        }
        #endregion
    }
}
